// ==UserScript==
// @author      loviuz
// @name        No Cookiewall Italia
// @namespace   https://este.linux.it
// @version     1.5.0
// @include       *://*
// @license     AGPL v3
// @description Permette di navigare siti web italiani di notizie evitando il cookiewall, il quale permette di accedere ai contenuti, già arrivati al browser, previa accettazione cookie o il pagamento di un abbonamento. Alcuni stabiliscono che questo comportamento dei siti non è lecito secondo il GDPR: in attesa di una pronuncia del garante della privacy propongo questo metodo per saltare questo blocco.
// @lang         it
// ==/UserScript==


var cookiewall_found = false;

var ci = setInterval( function(){
    // Identifica il tipo di cookiewall
    var is_iubenda = document.querySelector('#iubenda-cs-banner') || document.querySelector('#iubenda-cs-banner');
    var is_privacycpwall = document.querySelector('.wall-modal') || document.querySelector('.privacy-cp-wall');
    var is_onetrust_banner_sdk = document.querySelector('#onetrust-banner-sdk');

    if (is_iubenda) {
        var cookiewall_desktop = document.querySelector('.prompt-to-accept');
        var cookiewall_mobile = document.querySelector('#iubenda-cs-banner');

        // Cookiewall desktop
        if (cookiewall_desktop) {
            cookiewall_desktop.style.display = 'none';
            document.querySelector('html').classList.remove('show-prompt-to-accept');
            document.querySelector('html').style.overflow = 'auto';
            cookiewall_found = true;
        }
        
        // Cookiewall mobile
        if (cookiewall_mobile) {
            document.querySelector('#iubenda-cs-banner.iubenda-cs-visible').classList.remove('iubenda-cs-visible');
            cookiewall_mobile.setAttribute('style', 'display:none !important');
            document.querySelector('html').setAttribute('style', '');
            document.querySelector('.adv-slot').style.display = 'none';
            cookiewall_found = true;
        }
    }

    else if(is_privacycpwall){
        var cookiewall_desktop = document.querySelector('.wall-modal');
        var cookiewall_mobile = document.querySelector('.privacy-cp-wall');

        // Cookiewall desktop
        if (cookiewall_desktop) {
            cookiewall_desktop.style.display = 'none';
            document.querySelector('.tp-backdrop').style.display = 'none';
            document.querySelector('body').classList.remove('tp-modal-open');
            cookiewall_found = true;
        }

        // Cookiewall mobile
        if (cookiewall_mobile) {
            cookiewall_mobile.style.display = 'none';
            document.querySelector('body').classList.remove('noScroll');
            cookiewall_found = true;
        }
    }

    else if(is_onetrust_banner_sdk){
        var cookiewall = document.querySelector('#onetrust-banner-sdk');

        // Cookiewall
        if (cookiewall) {
            cookiewall.style.position = 'absolute';
            cookiewall.style.left = '-10000px';

            document.querySelector('.onetrust-pc-dark-filter').style.position = 'absolute';
            document.querySelector('.onetrust-pc-dark-filter').style.left = '-10000px';

            document.querySelector('body').setAttribute('style', '');
            cookiewall_found = true;
        }
    }

    if (cookiewall_found) {
        clearInterval(ci);
    }
}, 1000 );
